//+------------------------------------------------------------------+
//|                                 TrendEnvelopeCOL_DEM.mq4         |
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "TrendEnvelopeCOL_DEM"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 Aqua
#property indicator_color4 Magenta

extern int        MA_Per           = 40 ;
extern int        MA_SiEmSmWe3     = 3 ;//1

extern   int      DEMA_Period      = 25;
extern   int      DEMA_Mode        = 1;  
extern   int      DEMA_Applied     = PRICE_CLOSE;


extern int     LineStyle      = 0 ;
extern int     LineSize       = 2 ;
extern int     CountBars      = 1000 ;

double UpBufferG[];
double UpBufferR[];
double DnBufferG[];
double DnBufferR[];

double MaBuffer[];
double DEMABuffer[];
double DownBuffer[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits (+4);
   IndicatorBuffers(7);
   SetIndexStyle (0,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(0,UpBufferG);
   SetIndexStyle (1,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(1,UpBufferR);
   SetIndexStyle (2,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(2,DnBufferG);
   SetIndexStyle (3,DRAW_LINE, LineStyle, LineSize);
   SetIndexBuffer(3,DnBufferR);

  SetIndexBuffer(4,MaBuffer);
  SetIndexBuffer(5,DEMABuffer);
  SetIndexBuffer(6,DownBuffer);


//==============================================================================
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  { 
    int i = 0;
    int limit;
    int counted_bars=IndicatorCounted();

    if (Bars<=MA_Per ) return(0);
    if (counted_bars<0) return(-1);
    if (counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars-1;
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);

//==============================================================================       
   
         {    string  ThisName = "TEDEM";
              string Text=ThisName;
              Text=Text+"(";
              Text=Text+"Per "+DoubleToStr(MA_Per,0);
              Text=Text+", Ma "+DoubleToStr(MA_SiEmSmWe3,0);
              Text=Text+")";
              IndicatorShortName(Text); 
         }        
//==============================================================================  
    for(i=0; i<limit; i++)
     {  UpBufferG[i] = iMA(NULL,0,MA_Per,0,MA_SiEmSmWe3,PRICE_HIGH,i);
        DnBufferG[i] = iMA(NULL,0,MA_Per,0,MA_SiEmSmWe3,PRICE_LOW,i);
     }
//==============================================================================                
   for(i=0; i<limit; i++)
         {
           MaBuffer[i] = iMA(NULL,0,DEMA_Period,0,DEMA_Mode,DEMA_Applied,i);
         }
     for(i=0; i<limit; i++)
        {
          DEMABuffer[i] = iMAOnArray(MaBuffer,0,DEMA_Period,0,DEMA_Mode,i);
        }
   
//=======================  COLOR CODE DEMA ========================================   
    for(i=0; i<limit; i++)
   {      DownBuffer[i] = EMPTY_VALUE;
      
      if   ( DEMABuffer[i + 1] < DEMABuffer[i] )  {DownBuffer[i + 1] = DownBuffer[i + 1];
                                               DownBuffer[i] = DownBuffer[i];
           }
     else 
          {  if  (DEMABuffer[i + 1] > DEMABuffer[i])
                 {
                   if (DownBuffer[i + 1] == EMPTY_VALUE) DownBuffer[i + 1] = DEMABuffer[i + 1];
                                                          DownBuffer[i] = DEMABuffer[i];
   }      }      }      

//=======================  COLOR CODE A ========================================   
     for(i=0; i<limit; i++)
   {  if   (  DownBuffer[i] == EMPTY_VALUE )  {UpBufferG[i] =  UpBufferG[i];
           }
      if  (   DownBuffer[i] != EMPTY_VALUE ) {UpBufferR[i] =  UpBufferG[i];
   }      }   
//=======================  COLOR CODE A ========================================   
     for(i=0; i<limit; i++)
   {  if   (  DownBuffer[i] == EMPTY_VALUE )  {DnBufferG[i] =  DnBufferG[i];
           }
      if  (   DownBuffer[i] != EMPTY_VALUE ) {DnBufferR[i] =  DnBufferG[i];
   }      }        
   return(0);
  }
//+----------------------------------------------------------------------------+